/*
 * LinesFrame.java
 *
 * Created on November 30, 2001, 1:39 PM
 */

/**
 *
 * @author  jplsp
 */

import java.io.*;

public class LinesFrame extends javax.swing.JFrame implements LinesManager{

    /* player name, set through interface function by whoever */
    private String playerName = "";
    
    /* current score */
    private int score;
    
    /** Creates new form LinesFrame */
    public LinesFrame() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jMenuBarMain = new javax.swing.JMenuBar();
        jMenuGame = new javax.swing.JMenu();
        jMenuItemOptions = new javax.swing.JMenuItem();
        jMenuItemShowScore = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItemExit = new javax.swing.JMenuItem();
        jMenuDebug = new javax.swing.JMenu();
        jMenuItemTDrop = new javax.swing.JMenuItem();
        jMenuItemVictory = new javax.swing.JMenuItem();
        jMenuHelp = new javax.swing.JMenu();
        jMenuItemAbout = new javax.swing.JMenuItem();
        jPanelScore = new javax.swing.JPanel();
        jLabelScorePrompt = new javax.swing.JLabel();
        jLabelScore = new javax.swing.JLabel();
        linesField = new LinesField();
        
        jMenuGame.setText("Game");
        jMenuItemOptions.setText("Options");
        jMenuItemOptions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOptionsActionPerformed(evt);
            }
        });
        
        jMenuGame.add(jMenuItemOptions);
        jMenuItemShowScore.setText("Show high scores");
        jMenuItemShowScore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemShowScoreActionPerformed(evt);
            }
        });
        
        jMenuGame.add(jMenuItemShowScore);
        jMenuGame.add(jSeparator1);
        jMenuItemExit.setText("Exit");
        jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExitActionPerformed(evt);
            }
        });
        
        jMenuGame.add(jMenuItemExit);
        jMenuBarMain.add(jMenuGame);
        jMenuDebug.setText("Debug");
        jMenuItemTDrop.setText("threeDrop");
        jMenuItemTDrop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemTDropActionPerformed(evt);
            }
        });
        
        jMenuDebug.add(jMenuItemTDrop);
        jMenuItemVictory.setText("victory");
        jMenuItemVictory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemVictoryActionPerformed(evt);
            }
        });
        
        jMenuDebug.add(jMenuItemVictory);
        jMenuBarMain.add(jMenuDebug);
        jMenuHelp.setText("Help");
        jMenuItemAbout.setText("About");
        jMenuHelp.add(jMenuItemAbout);
        jMenuBarMain.add(jMenuHelp);
        
        setTitle("jLines");
        setName("linesFrame");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jPanelScore.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabelScorePrompt.setText("Score:");
        jPanelScore.add(jLabelScorePrompt);
        
        jPanelScore.add(jLabelScore);
        
        getContentPane().add(jPanelScore, java.awt.BorderLayout.NORTH);
        
        getContentPane().add(linesField, java.awt.BorderLayout.CENTER);
        
        setJMenuBar(jMenuBarMain);
        pack();
    }//GEN-END:initComponents

    private void jMenuItemOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOptionsActionPerformed
        OptionsDialog d;
        
        d = new OptionsDialog( this, true );
        d.setManager( this );
        d.setLinesField( linesField );
        d.show();
        
        repaint();
        
    }//GEN-LAST:event_jMenuItemOptionsActionPerformed

    private void jMenuItemShowScoreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemShowScoreActionPerformed
        showHighScores();
    }//GEN-LAST:event_jMenuItemShowScoreActionPerformed

    private void jMenuItemVictoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemVictoryActionPerformed
        victory();
    }//GEN-LAST:event_jMenuItemVictoryActionPerformed

    private void jMenuItemTDropActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemTDropActionPerformed
        boolean spaceLeft;
        spaceLeft = linesField.threeDrop();
        linesField.repaint();
        
        if (!spaceLeft)
            victory();
    }//GEN-LAST:event_jMenuItemTDropActionPerformed

    private void jMenuItemExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExitActionPerformed
        System.exit( 0 );
    }//GEN-LAST:event_jMenuItemExitActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        LinesFrame linesFrame = new LinesFrame();
        linesFrame.show();
        
        linesFrame.setScore( 0 );

        linesFrame.linesField.setFieldSize( LinesField.DefaultFieldSize );
        linesFrame.linesField.setNumberOfColors( LinesField.DefaultNOfColors );

        linesFrame.linesField.setManager(linesFrame);
        linesFrame.linesField.threeDrop();
        linesFrame.linesField.repaint();
    }

    private void setScore(int _score) {
        score = _score;
        jLabelScore.setText( Integer.toString( score ) );
    }    

    public void improveScore(int dBalls) {
        int dScore;
        dScore = score + dBalls*2;
        if (dBalls-linesField.getShortestChain()-1 > 0)
            dScore += (int)Math.pow(2.0,
                (double)(dBalls-linesField.getShortestChain()-1));
        setScore(dScore);
    }    

    public void resetScore(){
        setScore( 0 );
    }
    
    public void setPlayerName( String _playerName ){
        playerName = _playerName;
    }
    
    public String getPlayerName(){
        return playerName;
    }
    
    private void showHighScores(){
        LinesRecord record;
        RecordDialog d;
        
        record = new LinesRecord();
        record.initFromFile();
        
        d = new RecordDialog(this, true);
        d.initRecord( record );
        d.show();
    }
    
    public void victory(){
        LinesRecord record;
        VictoryDialog d;
        
        record = new LinesRecord();
        record.initFromFile();
        if (record.newRecord( score ) == true){
            d = new VictoryDialog(this, true);
            d.setManager( this );
            /* this will change the playerName */
            d.show();
        
            record.addRecord(score, playerName);
            record.sync();
            showHighScores();
        }

        /* cleaning the field */
        linesField.resetField();
        
        setScore( 0 );
        linesField.threeDrop();
        linesField.repaint();
    }
 
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBarMain;
    private javax.swing.JMenu jMenuGame;
    private javax.swing.JMenuItem jMenuItemOptions;
    private javax.swing.JMenuItem jMenuItemShowScore;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenuItem jMenuItemExit;
    private javax.swing.JMenu jMenuDebug;
    private javax.swing.JMenuItem jMenuItemTDrop;
    private javax.swing.JMenuItem jMenuItemVictory;
    private javax.swing.JMenu jMenuHelp;
    private javax.swing.JMenuItem jMenuItemAbout;
    private javax.swing.JPanel jPanelScore;
    private javax.swing.JLabel jLabelScorePrompt;
    private javax.swing.JLabel jLabelScore;
    private LinesField linesField;
    // End of variables declaration//GEN-END:variables

}
