/*
 * OptionsDialog.java
 *
 * Created on December 7, 2001, 11:09 AM
 */

/**
 *
 * @author  jplsp
 */
public class OptionsDialog extends javax.swing.JDialog {

    private LinesField linesField;
    private LinesManager manager;
    
    /** Creates new form OptionsDialog */
    public OptionsDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jButtonRestart = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabelColors = new javax.swing.JLabel();
        jSliderColors = new javax.swing.JSlider();
        jLabelFieldSize = new javax.swing.JLabel();
        jSliderFieldSize = new javax.swing.JSlider();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("Options");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        jButtonRestart.setText("Restart Game");
        jButtonRestart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRestartActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 10, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jButtonRestart, gridBagConstraints1);
        
        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 10, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jButtonCancel, gridBagConstraints1);
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        jLabelColors.setText("Number of Colours");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(10, 20, 0, 20);
        jPanel1.add(jLabelColors, gridBagConstraints2);
        
        jSliderColors.setMajorTickSpacing(1);
        jSliderColors.setMaximum(10);
        jSliderColors.setMinimum(4);
        jSliderColors.setPaintLabels(true);
        jSliderColors.setPaintTicks(true);
        jSliderColors.setSnapToTicks(true);
        jSliderColors.setValue(5);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.insets = new java.awt.Insets(0, 20, 0, 20);
        jPanel1.add(jSliderColors, gridBagConstraints2);
        
        jLabelFieldSize.setText("Field Size");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 3;
        gridBagConstraints2.insets = new java.awt.Insets(10, 20, 0, 20);
        jPanel1.add(jLabelFieldSize, gridBagConstraints2);
        
        jSliderFieldSize.setMajorTickSpacing(1);
        jSliderFieldSize.setMaximum(15);
        jSliderFieldSize.setMinimum(7);
        jSliderFieldSize.setPaintLabels(true);
        jSliderFieldSize.setPaintTicks(true);
        jSliderFieldSize.setSnapToTicks(true);
        jSliderFieldSize.setValue(9);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.insets = new java.awt.Insets(0, 20, 10, 20);
        jPanel1.add(jSliderFieldSize, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(jPanel1, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        setVisible(false);
        dispose();        
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonRestartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRestartActionPerformed
        
        manager.resetScore();
        linesField.setFieldSize( jSliderFieldSize.getValue() );
        linesField.setNumberOfColors( jSliderColors.getValue() );
        linesField.threeDrop();
        
        setVisible(false);
        dispose();        
    }//GEN-LAST:event_jButtonRestartActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new OptionsDialog(new javax.swing.JFrame(), true).show();
    }

    public void setLinesField( LinesField _linesField ){
        linesField = _linesField;
        jSliderColors.setValue( linesField.getNumberOfColors() );
        jSliderFieldSize.setValue( linesField.getFieldSize() );
    }
    
    public void setManager (LinesManager _manager){
        manager = _manager;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonRestart;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel jLabelColors;
    private javax.swing.JSlider jSliderColors;
    private javax.swing.JLabel jLabelFieldSize;
    private javax.swing.JSlider jSliderFieldSize;
    // End of variables declaration//GEN-END:variables

}
